#include "animation.h"

Animation *loadAnimation(char *name, int frameTime)
{
	int i;
	char filename[255];
	Animation *anim = (Animation *)calloc(1, sizeof(Animation));

	if (anim == NULL)
	{
		printf("Could not create animation for %s\n", name);

		exit(1);
	}

	for (i=0;i<MAX_FRAMES;i++)
	{
		sprintf(filename, INSTALL_DIR"gfx/%s%04d.png", name, (i + 1));
		
		anim->frame[i] = IMG_Load(filename);

		if (anim->frame[i] != NULL)
		{
			SDL_SetColorKey(anim->frame[i], (SDL_SRCCOLORKEY|SDL_RLEACCEL), SDL_MapRGB(anim->frame[i]->format, 0, 0, 0));

			anim->frames++;
		}

		else
		{
			break;
		}
	}

	anim->frameTime = frameTime;
	
	return anim;
}

void freeAnimations()
{
	int i, j;
	
	for (i=0;i<MAX_ANIMATIONS;i++)
	{
		if (animation != NULL)
		{
			for (j=0;j<MAX_FRAMES;j++)
			{
				if (animation[i]->frame[j] != NULL)
				{
					SDL_FreeSurface(animation[i]->frame[j]);
				}
			}
		}
	}
}
