#include "bullets.h"

extern int getFreeEntity(void);
extern void calculatePathToTarget(Entity *, float, float);
extern void standardMove(void);

void addBullet(float targetX, float targetY, int speed)
{
	int i = getFreeEntity();

	if (i == -1)
	{
		return;
	}

	entities[i].x = self->x + (self->type == ENEMY ? 0 : self->width);
	entities[i].y = self->y + self->height / 2;
	entities[i].targetX = targetX;
	entities[i].targetY = targetY;
	entities[i].damage = 1;
	entities[i].type = (self->type == ENEMY ? ENEMY_BULLET : PLAYER_BULLET);
	entities[i].move = &standardMove;
	entities[i].width = (self->type == ENEMY ? 4 : 8);
	entities[i].height = (self->type == ENEMY ? 4 : 8);

	calculatePathToTarget(&entities[i], entities[i].targetX, entities[i].targetY);

	entities[i].dx *= speed;
	entities[i].dy *= speed;
	
	entities[i].sprite = animation[(self->type == ENEMY ? ENEMY_BULLET_ANIMATION : PLAYER_BULLET_ANIMATION)];
	entities[i].frameTime = animation[(self->type == ENEMY ? ENEMY_BULLET_ANIMATION : PLAYER_BULLET_ANIMATION)]->frameTime;
	entities[i].frame = 0;
	
	entities[i].width = animation[(self->type == ENEMY ? ENEMY_BULLET_ANIMATION : PLAYER_BULLET_ANIMATION)]->frame[0]->w;
	entities[i].height = animation[(self->type == ENEMY ? ENEMY_BULLET_ANIMATION : PLAYER_BULLET_ANIMATION)]->frame[0]->h;
	
	entities[i].y -= entities[i].height / 2;
}
