#include "collisions.h"

extern void playSound(int);
extern void addRandomParticle(float, float);
extern long prand(void);
extern void addScore(void);

int collision(float, float, int, int, float, float, int, int);

void doCollisions()
{
	int i, j, k, particles;

	/* Player to Entity */

	if (player.active == 1)
	{
		for (i=0;i<MAX_ENTITIES;i++)
		{
			if (entities[i].active == 0 || entities[i].type == PLAYER_BULLET || entities[i].type == SCORE)
			{
				continue;
			}

			if (collision(player.x, player.y, player.width, player.height, entities[i].x, entities[i].y, entities[i].width, entities[i].height) == 1)
			{
				if (entities[i].type != SCORE_POD)
				{
					particles = 10 + prand() % 20;

					for (k=0;k<particles;k++)
					{
						addRandomParticle(player.x + player.width / 2, player.y + player.height / 2);
					}

					player.active = 0;

					player.health = 120;

					game.status = GAME_STATUS_GAME_OVER;

					player.action = player.die;
				}
				
				self = &entities[i];
				
				addScore();

				game.score += entities[i].score;

				entities[i].active = 0;
			}
		}
	}

	/* Entity to Entity */

	for (i=0;i<MAX_ENTITIES;i++)
	{
		if (entities[i].active == 0 || entities[i].type != PLAYER_BULLET)
		{
			continue;
		}

		for (j=0;j<MAX_ENTITIES;j++)
		{
			if (entities[j].active == 0 || entities[j].type != ENEMY || entities[j].x >= SCREEN_WIDTH)
			{
				continue;
			}

			if (collision(entities[i].x, entities[i].y, entities[i].width, entities[i].height, entities[j].x, entities[j].y, entities[j].width, entities[j].height) == 1)
			{
				entities[j].health -= entities[i].damage;

				particles = 5 + prand() % 5;

				for (k=0;k<particles;k++)
				{
					addRandomParticle(entities[j].x, entities[j].y);
				}

				if (entities[j].health <= 0)
				{
					self = &entities[j];
					
					playSound(EXPLOSION_SND);

					game.score += entities[j].score;

					if (entities[j].die != NULL)
					{
						entities[j].die();
					}
					
					addScore();

					entities[j].active = 0;
				}

				else
				{
					playSound(BULLET_HIT_SND);
				}

				entities[i].active = 0;
			}
		}
	}
}

int collision(float x0, float y0, int w0, int h0, float x2, float y2, int w1, int h1)
{
	float x1 = x0 + w0;
	float y1 = y0 + h0;

	float x3 = x2 + w1;
	float y3 = y2 + h1;

	return !(x1<x2 || x3<x0 || y1<y2 || y3<y0);
}
