#include "draw.h"

extern void drawStars(void);
extern void drawPlayer(void);
extern void drawEntities(void);
extern void drawCachedString(int, int, int, int, int);
extern void drawString(char *, int, int, int, int, int, TTF_Font *, SDL_Color);
extern void drawParticles(void);

void drawGame()
{
	static char score[10], highScore[10];
	
	SDL_FillRect(screen, NULL, colors[BLACK]);
	
	sprintf(score, "%09d", game.score);
	sprintf(highScore, "%09d", game.highScore);
	
	drawStars();
	drawEntities();
	drawPlayer();
	drawParticles();

	drawCachedString(STRING_SCORE, 25, 5, 0, 0);
	drawString(score, 100, 5, 0, 0, 1, standardFont, whiteColor);

	drawCachedString(STRING_HIGH_SCORE, 300, 5, 0, 0);
	drawString(highScore, 425, 5, 0, 0, 1, standardFont, whiteColor);

	if (game.status == GAME_STATUS_INTRO)
	{
		drawCachedString(STRING_GET_READY, 25, 5, 1, 1);
	}

	else if (game.status == GAME_STATUS_GAME_OVER)
	{
		drawCachedString(STRING_GAME_OVER, 25, 5, 1, 1);
	}

	SDL_Flip(screen);
}
