#include "entities.h"

void standardDraw(void);

void resetEntities()
{
	int i;

	for (i=0;i<MAX_ENTITIES;i++)
	{
		memset(&entities[i], 0, sizeof(Entity));
	}
}

int getFreeEntity()
{
	int i;

	for (i=0;i<MAX_ENTITIES;i++)
	{
		if (entities[i].active == 0)
		{
			memset(&entities[i], 0, sizeof(Entity));

			entities[i].active = 1;

			entities[i].draw = &standardDraw;

			return i;
		}
	}

	printf("No more Free Entities\n");

	exit(1);
}

void doEntities()
{
	int i;

	for (i=0;i<MAX_ENTITIES;i++)
	{
		self = &entities[i];

		if (self->active == 0)
		{
			continue;
		}

		if (self->sprite != NULL)
		{
			self->frameTime--;

			if (self->frameTime <= 0)
			{
				self->frame++;

				self->frameTime = self->sprite->frameTime;

				if (self->frame >= MAX_FRAMES || self->frame >= self->sprite->frames)
				{
					self->frame = 0;
				}
			}
		}

		if (self->action != NULL)
		{
			self->action();
		}

		else
		{
			self->move();

			if (player.active == 1 && self->attack != NULL && self->x > 0 && self->x < SCREEN_WIDTH && self->y > 0 && self->y < SCREEN_HEIGHT)
			{
				self->attack();
			}
		}
	}
}

void drawEntities()
{
	int i;

	for (i=0;i<MAX_ENTITIES;i++)
	{
		self = &entities[i];

		if (self->active == 0)
		{
			continue;
		}
		
		self->draw();
	}
}

void standardDraw()
{
	SDL_Rect src, dest;
	
	src.x = self->x;
	src.y = self->y;
	src.w = self->width;
	src.h = self->height;
	
	if (self->sprite != NULL)
	{
		src.x = 0;
		src.y = 0;
		src.w = self->sprite->frame[self->frame]->w;
		src.h = self->sprite->frame[self->frame]->h;
		
		dest.x = self->x;
		dest.y = self->y;
		dest.w = self->sprite->frame[self->frame]->w;
		dest.h = self->sprite->frame[self->frame]->h;

		SDL_BlitSurface(self->sprite->frame[self->frame], &src, screen, &dest);
	}

	else
	{
		printf("Couldn't find image for entity type %d\n", self->type);
		
		exit(0);
	}
}

void flickerDraw()
{
	if (self->health < 120 && self->health % 2 == 0)
	{
		return;
	}

	standardDraw();
}
