#include "movement.h"

void standardMove()
{
	self->x += self->dx;
	self->y += self->dy;

	/* Moving too far off the screen automatically kills */

	if (self->x < -MAX_OFFSET || self->x > SCREEN_WIDTH + MAX_OFFSET_RIGHT || self->y < -MAX_OFFSET || self->y > SCREEN_HEIGHT + MAX_OFFSET)
	{
		if (player.active != 0)
		{
			game.score -= self->score;
			
			if (game.score < 0)
			{
				game.score = 0;
			}
		}
		
		self->active = 0;
	}
}

void curveMove()
{
	self->x += self->dx;
	self->y  = sin(self->x * 0.01) * 100 + SCREEN_HEIGHT / 2;

	/* Moving too far off the screen automatically kills */

	if (self->x < -MAX_OFFSET || self->x > SCREEN_WIDTH + MAX_OFFSET_RIGHT)
	{
		if (player.active != 0)
		{
			game.score -= self->score;
			
			if (game.score < 0)
			{
				game.score = 0;
			}
		}
		
		self->active = 0;
	}
}

void bounceMove()
{
	self->x += self->dx;
	self->y += self->dy;

	self->health--;

	if (self->health <= 0)
	{
		self->active = 0;
	}

	/* Bounce off the edge of the screen */

	if (self->x < 0 || self->x + self->width > SCREEN_WIDTH)
	{
		self->dx *= -1;
	}

	if (self->y < 0 || self->y + self->height > SCREEN_HEIGHT)
	{
		self->dy *= -1;
	}
}

void scoreMove()
{
	self->x += self->dx;
	self->y += self->dy;

	self->health--;

	if (self->health <= 0)
	{
		self->die();
		
		self->active = 0;
	}
}
