#include "particles.h"

extern long prand(void);

int getFreeParticle(void);

void resetParticles()
{
	int i;

	for (i=0;i<MAX_PARTICLES;i++)
	{
		memset(&particles[i], 0, sizeof(Star));
	}
}

void addRandomParticle(float x, float y)
{
	int i = getFreeParticle();

	if (i == -1)
	{
		return;
	}

	particles[i].x = x;
	particles[i].y = y;
	particles[i].dx = (prand() % 60) * (prand() % 2 == 1 ? -1 : 1);
	particles[i].dy = (prand() % 60) * (prand() % 2 == 1 ? -1 : 1);
	
	particles[i].dx /= 10;
	particles[i].dy /= 10;

	particles[i].health = 10 + prand() % 80;
	particles[i].color = prand() % MAX_COLORS;
}

int getFreeParticle()
{
	int i;

	for (i=0;i<MAX_PARTICLES;i++)
	{
		if (particles[i].health <= 0)
		{
			return i;
		}
	}

	return -1;
}

void doParticles()
{
	int i;

	for (i=0;i<MAX_PARTICLES;i++)
	{
		if (particles[i].health <= 0)
		{
			continue;
		}

		particles[i].health--;

		particles[i].x += particles[i].dx;
		particles[i].y += particles[i].dy;
	}
}

void drawParticles()
{
	int i;
	SDL_Rect rect;

	for (i=0;i<MAX_PARTICLES;i++)
	{
		if (particles[i].health <= 0)
		{
			continue;
		}
		
		rect.x = particles[i].x;
		rect.y = particles[i].y;
		rect.w = 1;
		rect.h = 1;

		SDL_FillRect(screen, &rect, colors[particles[i].color]);
	}
}
