#include "score.h"

extern long prand(void);
extern void bounceMove(void);
extern void flickerDraw(void);
extern int getFreeEntity(void);
extern void addRandomParticle(float, float);
extern SDL_Surface *generateString(char *, int, TTF_Font *, SDL_Color);
extern void scoreMove(void);
extern void standardDraw(void);

void freeAnimation(void);

void dropScorePod()
{
	int i;
	
	for (i=0;i<50;i++)
	{
		addRandomParticle(self->x + self->width / 2, self->y + self->height / 2);
	}

	if (prand() % 5 == 0)
	{
		i = getFreeEntity();

		if (i == -1)
		{
			return;
		}

		entities[i].type = SCORE_POD;
		entities[i].x = self->x;
		entities[i].y = self->y;
		entities[i].dx = (1 + prand() % 3) * (prand() % 2 == 0 ? -1 : 1);
		entities[i].dy = (1 + prand() % 3) * (prand() % 2 == 0 ? -1 : 1);
		entities[i].health = 300 + (prand() % 600);
		entities[i].width = 16;
		entities[i].height = 16;
		entities[i].score = self->score * 5;

		entities[i].move = &bounceMove;
		entities[i].draw = &flickerDraw;

		entities[i].sprite = animation[POINTS_ANIMATION];
		entities[i].frameTime = animation[POINTS_ANIMATION]->frameTime;
		entities[i].frame = 0;
		
		if (entities[i].x + entities[i].width >= SCREEN_WIDTH)
		{
			entities[i].x = SCREEN_WIDTH - entities[i].width - 1;
		}
		
		if (entities[i].y + entities[i].height >= SCREEN_HEIGHT)
		{
			entities[i].y = SCREEN_HEIGHT - entities[i].height - 1;
		}
	}
}

void addScore()
{
	int i;
	Animation *anim;
	char text[10];
	
	if (self->score <= 0)
	{
		return;
	}
	
	i = getFreeEntity();
	
	if (i == -1)
	{
		return;
	}
	
	sprintf(text, "%d", self->score);
	
	anim = (Animation *)calloc(1, sizeof(Animation));
	
	anim->frames = 2;
	
	anim->frameTime = 2;
	
	anim->frame[0] = generateString(text, 1, standardFont, redColor);
	anim->frame[1] = generateString(text, 1, standardFont, yellowColor);

	entities[i].type = SCORE;
	entities[i].x = self->x;
	entities[i].y = self->y;
	entities[i].dx = 0;
	entities[i].dy = -0.6;
	entities[i].health = 60;
	entities[i].score = 0;

	entities[i].move = &scoreMove;
	entities[i].draw = &standardDraw;

	entities[i].sprite = anim;
	entities[i].frameTime = 2;
	entities[i].frame = 0;
	
	entities[i].die = &freeAnimation;
	
	if (entities[i].x + entities[i].width >= SCREEN_WIDTH)
	{
		entities[i].x = SCREEN_WIDTH - entities[i].width - 1;
	}
		
	if (entities[i].y + entities[i].height >= SCREEN_HEIGHT)
	{
		entities[i].y = SCREEN_HEIGHT - entities[i].height - 1;
	}
}

void freeAnimation()
{
	SDL_FreeSurface(self->sprite->frame[0]);
	SDL_FreeSurface(self->sprite->frame[1]);
}

