#include "settings.h"

void setDefaults(void);

void saveSettings()
{
	char filename[MAX_PATH];
	FILE *fp;

	sprintf(filename, "%sconfig.dat", game.savePath);

	fp = fopen(filename, "wb");

	printf("Saving settings %s\n", filename);

	if (fp == NULL)
	{
		printf("Failed to save settings, could not open file\n");

		return;
	}

	fwrite(&game.fullscreen, sizeof(game.fullscreen), 1, fp);

	fwrite(&game.highScore, sizeof(game.highScore), 1, fp);

	fwrite(userDefined.input, sizeof(userDefined.input), 1, fp);

	fwrite(&replayData.fileIndex, sizeof(replayData.fileIndex), 1, fp);

	fclose(fp);
}

void loadSettings()
{
	char filename[MAX_PATH];
	FILE *fp;

	sprintf(filename, "%sconfig.dat", game.savePath);

	printf("Loading settings %s\n", filename);

	fp = fopen(filename, "rb");

	if (fp == NULL)
	{
		printf("Failed to load settings, could not open file\n");

		setDefaults();

		return;
	}

	fread(&game.fullscreen, sizeof(game.fullscreen), 1, fp);

	fread(&game.highScore, sizeof(game.highScore), 1, fp);

	fread(userDefined.input, sizeof(userDefined.input), 1, fp);

	fread(&replayData.fileIndex, sizeof(replayData.fileIndex), 1, fp);

	fclose(fp);

	if (game.fullscreen == 1)
	{
		SDL_WM_ToggleFullScreen(screen);
	}
}

void setDefaults()
{
	userDefined.input[UP] = SDLK_UP;
	userDefined.input[DOWN] = SDLK_DOWN;
	userDefined.input[LEFT] = SDLK_LEFT;
	userDefined.input[RIGHT] = SDLK_RIGHT;
	userDefined.input[FIRE] = SDLK_LCTRL;
	userDefined.input[PAUSE] = SDLK_p;
}
