#include "stars.h"

extern long prand(void);

int getStarColor(int);

void resetStars()
{
	int i;

	for (i=0;i<MAX_STARS;i++)
	{
		stars[i].x = prand() % SCREEN_WIDTH;
		stars[i].y = prand() % SCREEN_HEIGHT;
		stars[i].speed = 1 + (prand() % 12);
		stars[i].color = getStarColor(stars[i].speed);
	}
}

void doStars()
{
	int i;

	for (i=0;i<MAX_STARS;i++)
	{
		stars[i].x -= stars[i].speed;

		if (stars[i].x <= 0)
		{
			stars[i].x = SCREEN_WIDTH + prand() % 20;
			stars[i].y = prand() % SCREEN_HEIGHT;
			stars[i].speed = 1 + (prand() % 12);
			stars[i].color = getStarColor(stars[i].speed);
		}
	}
}

void drawStars()
{
	int i;
	SDL_Rect rect;

	for (i=0;i<MAX_STARS;i++)
	{
		rect.x = stars[i].x;
		rect.y = stars[i].y;
		rect.w = 1;
		rect.h = 1;

		SDL_FillRect(screen, &rect, colors[stars[i].color]);
	}
}

int getStarColor(int speed)
{
	switch (speed)
	{
		case 1:
		case 2:
		case 3:
			return DARK_GREY;
				
		case 4:
		case 5:
		case 6:
			return GREY;
				
		case 7:
		case 8:
		case 9:
			return LIGHT_GREY;
			
		default:
			return WHITE;
	}
}
