#include "defs.h"

typedef struct Star
{
	int health, color;
	float x, y, dx, dy, speed;
} Star;

typedef struct Animation
{
	int frames, frameTime;
	SDL_Surface *frame[MAX_FRAMES];
} Animation;

typedef struct Entity
{
	int type, health, maxReload, reload;
	int active, score, ammo, maxAmmo;
	int thinkTime, maxThinkTime, damage;
	int width, height, frameTime, frame;
	float x, y, dx, dy, accelX, accelY;
	float targetX, targetY;
	Animation *sprite;
	void (*action)(void);
	void (*attack)(void);
	void (*die)(void);
	void (*move)(void);
	void (*draw)(void);
} Entity;

typedef struct Game
{
	char savePath[MAX_PATH], playerName[MAX_HIGHSCORE_NAME];
	int score, highScore, status, fullscreen;
	int recording, replaying, throttle;
	int paused, spawnTime, audio, online;
	unsigned long ticks;
} Game;

typedef struct Replay
{
	char input[REPLAY_BUFFER][MAX_CONTROLS];
	char filename[MAX_PATH];
	int seed, index, score, fileIndex;
	float version;
} Replay;

typedef struct Control
{
	int joyX, joyY;
	int input[MAX_CONTROLS];
} Control;

typedef struct Input
{
	char input[MAX_CONTROLS];
} Input;

typedef struct Sound
{
	Mix_Chunk *effect[MAX_SOUNDS];
} Sound;

typedef struct Menu
{
	int selectedEntry, frameTime, frame;
	int *entryValue;
	Animation *sprite;
} Menu;

typedef struct StringCache
{
	SDL_Surface *string[MAX_STRINGS];
} StringCache;

typedef struct HighScore
{
	char name[MAX_HIGHSCORE_NAME];
	int score;
	SDL_Surface *nameImage, *scoreImage;
} HighScore;
