#include "wave.h"

extern long prand(void);
extern void addWaveEnemy(int, int, int, float, int);

void createRandomWave()
{
	int waveType = prand() % MAX_WAVES;
	int enemies;
	int i, x, y;
	int attackType = prand() % 11;
	float speed;

	speed = (10 + prand() % 50);

	speed /= 10;

	switch (waveType)
	{
		case ROAD_BLOCK_WAVE:
			enemies = 1 + prand() % 6;

			for (i=0;i<enemies;i++)
			{
				x = SCREEN_WIDTH + 100;
				y = (SCREEN_HEIGHT - (enemies * ROAD_BLOCK_SPACING)) / 2 + (i * ROAD_BLOCK_SPACING);
				
				addWaveEnemy(x, y, waveType, speed, attackType);
			}
		break;

		case CURVE_WAVE:
			enemies = 1 + prand() % 10;

			y = 10 + prand() % (SCREEN_HEIGHT - 30);

			for (i=0;i<enemies;i++)
			{
				x = SCREEN_WIDTH + (i * STANDARD_SPACING);
				
				addWaveEnemy(x, y, waveType, speed, attackType);
			}
		break;

		default:
			enemies = 3 + prand() % 10;

			y = 10 + prand() % (SCREEN_HEIGHT - 30);

			for (i=0;i<enemies;i++)
			{
				x = SCREEN_WIDTH + (i * STANDARD_SPACING);
				
				addWaveEnemy(x, y, STRAIGHT_WAVE, speed, attackType);
			}
		break;
	}
}
