#include "weapons.h"

extern void addBullet(float, float, int);
extern void calculateTargetFromAngle(float *, float *, float);
extern void playSound(int);

void fireAimedShot()
{
	if (self->ammo > 0)
	{
		if (self->thinkTime <= 0)
		{
			self->ammo--;

			playSound(ENEMY_BULLET_SND);

			addBullet(player.x, player.y, ENEMY_BULLET_SPEED);

			self->thinkTime = self->maxThinkTime;
		}

		else
		{
			self->thinkTime--;
		}
	}

	else
	{
		self->reload--;

		if (self->reload <= 0)
		{
			self->ammo = self->maxAmmo;

			self->reload = self->maxReload;
		}
	}
}

void fire2WayShot()
{
	float targetX, targetY;

	if (self->ammo > 1)
	{
		if (self->thinkTime <= 0)
		{
			self->ammo -= 2;

			calculateTargetFromAngle(&targetX, &targetY, -15);

			playSound(ENEMY_BULLET_SND);

			addBullet(self->x - targetX, self->y + targetY + self->height / 2, ENEMY_BULLET_SPEED);

			calculateTargetFromAngle(&targetX, &targetY, 15);

			addBullet(self->x - targetX, self->y + targetY + self->height / 2, ENEMY_BULLET_SPEED);

			self->thinkTime = self->maxThinkTime;
		}

		else
		{
			self->thinkTime--;
		}
	}

	else
	{
		self->reload--;

		if (self->reload <= 0)
		{
			self->ammo = self->maxAmmo;

			self->reload = self->maxReload;
		}
	}
}

void fire4WayShot()
{
	float targetX, targetY;

	if (self->ammo > 3)
	{
		if (self->thinkTime <= 0)
		{
			self->ammo -= 4;

			calculateTargetFromAngle(&targetX, &targetY, -5);

			playSound(ENEMY_BULLET_SND);

			addBullet(self->x - targetX, self->y - targetY + self->height / 2, ENEMY_BULLET_SPEED);

			calculateTargetFromAngle(&targetX, &targetY, 5);

			addBullet(self->x - targetX, self->y - targetY + self->height / 2, ENEMY_BULLET_SPEED);

			calculateTargetFromAngle(&targetX, &targetY, -10);

			addBullet(self->x - targetX, self->y - targetY + self->height / 2, ENEMY_BULLET_SPEED);

			calculateTargetFromAngle(&targetX, &targetY, 10);

			addBullet(self->x - targetX, self->y - targetY + self->height / 2, ENEMY_BULLET_SPEED);

			self->thinkTime = self->maxThinkTime;
		}

		else
		{
			self->thinkTime--;
		}
	}

	else
	{
		self->reload--;

		if (self->reload <= 0)
		{
			self->ammo = self->maxAmmo;

			self->reload = self->maxReload;
		}
	}
}

void fire360Shot()
{
	float targetX, targetY, angle;

	if (self->ammo > 0)
	{
		if (self->thinkTime <= 0)
		{
			angle = self->ammo * 360;
			angle /= self->maxAmmo;
			
			calculateTargetFromAngle(&targetX, &targetY, angle);

			playSound(ENEMY_BULLET_SND);

			addBullet(self->x + (self->width / 2) - targetX, self->y - targetY + self->height / 2, ENEMY_BULLET_SPEED);

			self->ammo--;
			
			self->thinkTime = self->maxThinkTime;
		}

		else
		{
			self->thinkTime--;
		}
	}

	else
	{
		self->reload--;

		if (self->reload <= 0)
		{
			self->ammo = self->maxAmmo;

			self->reload = self->maxReload;
		}
	}
}
